package org.telosys.tools.repository ;

/**
 * @author Laurent GUERIN
 * 
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

public class UpdateLogWriter
{
    private final static int                LF              = 1;

    private final static int                CRLF            = 2;

    //--- Type de fin de ligne
    private int                             _iEndOfLine     = LF;
	
	private FileOutputStream _fos = null ;
	
    //-----------------------------------------------------------------------------
    //--- CONSTRUCTORS
    //-----------------------------------------------------------------------------
    public UpdateLogWriter(File file)
    {
        if (file != null)
        {
	    	init(file);
        }
        else
        {
        	throw new RuntimeException("LogWriter constructor : file parameter is null");
        	//MsgBox.error("LogWriter constructor : file parameter is null");
        }
    }
    
    private void init(File file)
    {
        try
        {
            _fos = new FileOutputStream(file);
        } catch (FileNotFoundException ex) // Si cration impossible
        {
        	throw new RuntimeException("LogWriter : Cannot create file '" + file.getAbsolutePath() + "'");
        	//MsgBox.error("LogWriter : Cannot create file '" + file.getAbsolutePath() + "'");
        }
    }
    
    //-----------------------------------------------------------------------------
    synchronized public void println( String msg )
    {
    	System.out.println("LogWritter.println (" + msg + ")");
        if (_fos != null)
        {
            try
            {
                _fos.write(msg.getBytes());
                if (_iEndOfLine == CRLF)
                {
                	_fos.write('\r');
                	_fos.write('\n');
                }
                else
                {
                	_fos.write('\n');
                }
                _fos.flush();
            } catch (IOException ex)
            {
            	throw new RuntimeException("LogWriter : cannot write (IOException)");
	        	//MsgBox.error("LogWriter : cannot write (IOException)");
            }
        }
    }
    //-----------------------------------------------------------------------------
    synchronized public void close()
    {
        if (_fos != null)
        {
        	try {
				_fos.close();
			} catch (IOException e) {
				throw new RuntimeException("LogWriter : cannot close (IOException)");
	        	//MsgBox.error("LogWriter : cannot close (IOException)");
			}
        }
    }
}