package org.telosys.tools.repository.config;

/**
 * @author L.GUERIN
 * 
 */
public interface InitializerChecker
{
//    public String about();

    /**
     * Returns the Java bean class name for the given table name
     * @param sTableName
     * @return
     */
    public String getJavaBeanClassName(String sTableName);
    

    /**
     * Returns the Java attribute name for the given column 
     * @param sColumnName the name of the column in the database
     * @param sColumnTypeName the native database type
     * @param iJdbcTypeCode the JDBC type code
     * @return the attribute name
     */
    public String getAttributeName(String sColumnName, String sColumnTypeName, int iJdbcTypeCode);

    
    /**
     * Returns the Java attribute type for the given column 
     * @param sColumnTypeName the native database type
     * @param iJdbcTypeCode the JDBC type code
     * @param bColumnNotNull flag "NOT NULL" column
     * @return the attribute type
     */
    public String getAttributeType(String sColumnTypeName, int iJdbcTypeCode, boolean bColumnNotNull );


    public String getAttributeLongTextFlag(String sColumnType, int iColumnTypeCode, String sJavaType );

    
    public String getAttributeDateType(String sColumnType, int iColumnTypeCode, String sJavaType );

}