package org.telosys.tools.repository.model;

/**
 * "joinColumn" model class <br>
 * <joinColumn name="EMPLOYEE_ID" table="" referencedColumnName="ID" unique="true|false" nullable="true|false" updatable="" insertable="" />
 * 
 * @author slabbe
 * 
 */
public class JoinColumn {

	private String name;

	private String referencedColumnName;

	private boolean unique = false;

	private boolean nullable = true;

	private boolean updatable = true;

	private boolean insertable = true;

	public String getCheckSum() {
		return name + "#" + referencedColumnName;
	}

	/**
	 * Control functionnal equality of JoinFK
	 * @param otherJoinFK
	 * @return if param link is equal to current link
	 */
	public boolean equals(final JoinColumn otherJoinColumn) {
		if (this.getCheckSum().equals(otherJoinColumn.getCheckSum())) {
			return true;
		} else {
			return false;
		}
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getReferencedColumnName() {
		return referencedColumnName;
	}

	public void setReferencedColumnName(String referencedColumnName) {
		this.referencedColumnName = referencedColumnName;
	}

	public boolean isUnique() {
		return unique;
	}

	public void setUnique(boolean unique) {
		this.unique = unique;
	}

	public boolean isNullable() {
		return nullable;
	}

	public void setNullable(boolean nullable) {
		this.nullable = nullable;
	}

	public boolean isUpdatable() {
		return updatable;
	}

	public void setUpdatable(boolean updatable) {
		this.updatable = updatable;
	}

	public boolean isInsertable() {
		return insertable;
	}

	public void setInsertable(boolean insertable) {
		this.insertable = insertable;
	}

}
