package org.telosys.tools.repository.persistence.commande;

import java.util.Iterator;
import java.util.List;

import org.telosys.tools.repository.model.Column;
import org.telosys.tools.repository.model.GeneratedValue;
import org.telosys.tools.repository.model.SequenceGenerator;
import org.telosys.tools.repository.model.TableGenerator;
import org.telosys.tools.repository.persistence.util.CommandException;
import org.telosys.tools.repository.persistence.util.ProcessContext;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Element;

public class CommandElementColumn extends AbstractCommand implements ICommandContext {

	public ProcessContext runProcess(final ProcessContext processContext, final ICommandManager iCommandManager) throws CommandException {
		final Element elem = processContext.getElement();

		// Transform element
		final Column column = RepositoryConst.COLUMN_WRAPPER.getColumn(elem);

		// Chain process
		final ProcessContext processContextNext = genericChildProcess(iCommandManager, elem);

		// Result analysis
		List objs = processContextNext.getList();
		for (Iterator iterator = objs.iterator(); iterator.hasNext();) {
			Object obj = iterator.next();
			if (obj instanceof GeneratedValue) {
				column.setGeneratedValue((GeneratedValue) obj);
			} else if (obj instanceof SequenceGenerator) {
				column.setSequenceGenerator((SequenceGenerator) obj);
			} else if (obj instanceof TableGenerator) {
				column.setTableGenerator((TableGenerator) obj);
			} else {
				throw new CommandException("Unsupported child on Column : " + obj.getClass());
			}
		}
		
		// Return result
		final ProcessContext context = new ProcessContext(column);
		return context;
	}

	public boolean accept(final ProcessContext processContext) {
		return genericAccept(processContext, RepositoryConst.COLUMN);
	}

}
