package org.telosys.tools.repository.persistence.commande;

import java.util.Iterator;
import java.util.List;

import org.telosys.tools.repository.model.ForeignKey;
import org.telosys.tools.repository.model.ForeignKeyColumn;
import org.telosys.tools.repository.persistence.util.CommandException;
import org.telosys.tools.repository.persistence.util.ProcessContext;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Element;

public class CommandElementForeignKey extends AbstractCommand implements ICommandContext {

	public ProcessContext runProcess(final ProcessContext processContext, final ICommandManager iCommandManager) throws CommandException {
		final Element elem = processContext.getElement();

		// Transform element
		final ForeignKey foreignKey = RepositoryConst.FOREIGNKEY_WRAPPER.getForeignKey(elem);
		
		// Chain process
		final ProcessContext processContextNext = genericChildProcess(iCommandManager, elem);

		// Result analysis
		List objs = processContextNext.getList();
		for (Iterator iterator = objs.iterator(); iterator.hasNext();) {
			Object obj = iterator.next();
			if (obj instanceof ForeignKeyColumn) {
				foreignKey.storeForeignKeyColumn((ForeignKeyColumn) obj);
			} else {
				throw new CommandException("Unsupported child on ForeignKey : " + obj.getClass());
			}
		}
		
		// Return result
		final ProcessContext context = new ProcessContext(foreignKey);
		return context;
	}

	public boolean accept(final ProcessContext processContext) {
		return genericAccept(processContext, RepositoryConst.FK);
	}

}
