package org.telosys.tools.repository.persistence.commande;

import org.telosys.tools.repository.model.ForeignKeyColumn;
import org.telosys.tools.repository.persistence.util.CommandException;
import org.telosys.tools.repository.persistence.util.ProcessContext;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Element;

public class CommandElementForeignKeyColumn extends AbstractCommand implements ICommandContext {

	public ProcessContext runProcess(final ProcessContext processContext, final ICommandManager iCommandManager) throws CommandException {
		final Element elem = processContext.getElement();

		// Transform element
		final ForeignKeyColumn foreignKeyColumn = RepositoryConst.FOREIGNKEY_COLUMN_WRAPPER.getForeignKeyColumn(elem);
		
		// Return result
		final ProcessContext context = new ProcessContext(foreignKeyColumn);
		return context;
	}

	public boolean accept(final ProcessContext processContext) {
		return genericAccept(processContext, RepositoryConst.FKCOL);
	}

}
