package org.telosys.tools.repository.persistence.commande;

import java.util.List;

import org.telosys.tools.repository.model.InverseJoinColumns;
import org.telosys.tools.repository.model.JoinColumn;
import org.telosys.tools.repository.persistence.util.CommandException;
import org.telosys.tools.repository.persistence.util.ProcessContext;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Element;

public class CommandElementInverseJoinColumns extends AbstractCommand implements ICommandContext 
{

	public ProcessContext runProcess(final ProcessContext processContext, final ICommandManager iCommandManager) throws CommandException {
		final Element elem = processContext.getElement();

		// Transform element
		//final JoinFK joinFK = RepositoryConst.JOIN_FK_WRAPPER.getJoinFK(elem);
		final InverseJoinColumns inverseJoinColumns = RepositoryConst.INVERSE_JOIN_COLUMNS_WRAPPER.getObject(elem);

		final ProcessContext processContextNext = genericChildProcess(iCommandManager, elem);

		List list = processContextNext.getList();
		for ( Object obj : list ) {
			if (obj instanceof JoinColumn) {
				inverseJoinColumns.add((JoinColumn) obj);
			} else {
				throw new CommandException("Unsupported child on JoinFK : " + obj.getClass());
			}
		}
//		for (Iterator iterator = list.iterator(); iterator.hasNext();) {
//			Object obj = iterator.next();
//			if (obj instanceof JoinColumn) {
//				inverseJoinColumns.add((JoinColumn) obj);
//			} else {
//				throw new CommandException("Unsupported child on JoinFK : " + obj.getClass());
//			}
//		}
		
		// Return result
		final ProcessContext context = new ProcessContext(inverseJoinColumns);
		return context;
	}

	public boolean accept(final ProcessContext processContext) {
		return genericAccept(processContext, RepositoryConst.INVERSE_JOIN_COLUMNS_ELEMENT);
	}

}
