package org.telosys.tools.repository.persistence.commande;

import org.telosys.tools.repository.model.JoinColumn;
import org.telosys.tools.repository.persistence.util.CommandException;
import org.telosys.tools.repository.persistence.util.ProcessContext;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Element;

public class CommandElementJoinColumn extends AbstractCommand implements ICommandContext {

	public ProcessContext runProcess(final ProcessContext processContext, final ICommandManager iCommandManager) throws CommandException {
		final Element elem = processContext.getElement();

		// Transform element
		final JoinColumn joinColumn = RepositoryConst.JOIN_COLUMN_WRAPPER.getJoinColumn(elem);
		
		// Return result
		final ProcessContext context = new ProcessContext(joinColumn);
		return context;
	}

	public boolean accept(final ProcessContext processContext) {
		return genericAccept(processContext, RepositoryConst.JOIN_COLUMN_ELEMENT);
	}

}
