package org.telosys.tools.repository.persistence.commande;

import java.util.List;

import org.telosys.tools.repository.model.JoinColumn;
import org.telosys.tools.repository.model.JoinColumns;
import org.telosys.tools.repository.persistence.util.CommandException;
import org.telosys.tools.repository.persistence.util.ProcessContext;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Element;

public class CommandElementJoinColumns extends AbstractCommand implements ICommandContext 
{

	public ProcessContext runProcess(final ProcessContext processContext, final ICommandManager iCommandManager) throws CommandException {
		final Element elem = processContext.getElement();

		// Transform element
		//final JoinFK joinFK = RepositoryConst.JOIN_FK_WRAPPER.getJoinFK(elem);
		final JoinColumns joinColumns = RepositoryConst.JOIN_COLUMNS_WRAPPER.getJoinColumns(elem);

		final ProcessContext processContextNext = genericChildProcess(iCommandManager, elem);

		List list = processContextNext.getList();
		//for (Iterator iterator = list.iterator(); iterator.hasNext();) 
		for (Object obj : list ) 
		{
			//Object obj = iterator.next();
			if (obj instanceof JoinColumn) {
				joinColumns.add((JoinColumn) obj);
			} else {
				throw new CommandException("Unsupported child on JoinFK : " + obj.getClass());
			}
		}
		
		// Return result
		final ProcessContext context = new ProcessContext(joinColumns);
		return context;
	}

	public boolean accept(final ProcessContext processContext) {
		return genericAccept(processContext, RepositoryConst.JOIN_COLUMNS_ELEMENT);
	}

}
