package org.telosys.tools.repository.persistence.commande;

import java.util.List;

import org.telosys.tools.repository.model.InverseJoinColumns;
import org.telosys.tools.repository.model.JoinColumns;
import org.telosys.tools.repository.model.JoinTable;
import org.telosys.tools.repository.persistence.util.CommandException;
import org.telosys.tools.repository.persistence.util.ProcessContext;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Element;

public class CommandElementJoinTable extends AbstractCommand implements ICommandContext {

	public ProcessContext runProcess(final ProcessContext processContext, final ICommandManager iCommandManager) throws CommandException {
		final Element elem = processContext.getElement();

		// Transform element
		final JoinTable joinTable = RepositoryConst.JOIN_TABLE_WRAPPER.getObject(elem);

//		final ProcessContext processContextNext = genericChildProcess(iCommandManager, elem);

//		List objs = processContextNext.getList();
//		for (Iterator iterator = objs.iterator(); iterator.hasNext();) {
//			Object obj = iterator.next();
//			if (obj instanceof JoinFK) {
//				joinTable.storeJoinFK((JoinFK) obj);
//			} else {
//				throw new CommandException("Unsupported child on JoinTable : " + obj.getClass());
//			}
//		}
		
		ProcessContext processContextNext = genericChildProcess(iCommandManager, elem);
		List list = processContextNext.getList();
		for ( Object obj : list ) {
			if (obj instanceof JoinColumns ) {
				joinTable.setJoinColumns( (JoinColumns) obj );
			}
			else if (obj instanceof InverseJoinColumns ) {
				joinTable.setInverseJoinColumns( (InverseJoinColumns) obj );
			}
			else {
				throw new CommandException("Unsupported child on Column : " + obj.getClass());
			}
		}
		
		// Return result
		final ProcessContext context = new ProcessContext(joinTable);
		return context;
	}

	public boolean accept(final ProcessContext processContext) {
		return genericAccept(processContext, RepositoryConst.JOIN_TABLE_ELEMENT);
	}

}
