package org.telosys.tools.repository.persistence.commande;

import java.util.Iterator;
import java.util.List;

import org.telosys.tools.repository.model.JoinColumns;
import org.telosys.tools.repository.model.JoinTable;
import org.telosys.tools.repository.model.Link;
import org.telosys.tools.repository.persistence.util.CommandException;
import org.telosys.tools.repository.persistence.util.ProcessContext;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Element;

public class CommandElementLink extends AbstractCommand implements ICommandContext {

	public ProcessContext runProcess(final ProcessContext processContext, final ICommandManager iCommandManager) throws CommandException {
		final Element elem = processContext.getElement();

		// Transform element
		final Link link = RepositoryConst.LINK_WRAPPER.getLink(elem);

		final ProcessContext processContextNext = genericChildProcess(iCommandManager, elem);

		List objs = processContextNext.getList();
		for (Iterator iterator = objs.iterator(); iterator.hasNext();) {
			Object obj = iterator.next();
//			if (obj instanceof JoinFK) {
//				link.storeJoinFK((JoinFK) obj);
//			} else 
			if (obj instanceof JoinTable) {
				link.setJoinTable((JoinTable) obj);
			} else if (obj instanceof JoinColumns) {
				link.setJoinColumns( (JoinColumns) obj );
			} else {
				throw new CommandException("Unsupported child on Link : " + obj.getClass());
			}
		}
		
		// Return result
		final ProcessContext context = new ProcessContext(link);
		return context;
	}

	public boolean accept(final ProcessContext processContext) {
		return genericAccept(processContext, RepositoryConst.LINK);
	}

}
