package org.telosys.tools.repository.persistence.commande;

import java.util.ArrayList;
import java.util.List;

import org.telosys.tools.repository.persistence.util.CommandException;
import org.telosys.tools.repository.persistence.util.ProcessContext;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class CommandNodeList extends AbstractCommand implements ICommandContext {

	public ProcessContext runProcess(final ProcessContext processContext, final ICommandManager iCommandManager) throws CommandException {
		final NodeList nl = processContext.getNodeList();
		
		// Transform NodeList to List
		final List<Object> maListe = new ArrayList<Object>();
		if ((nl != null) && (nl.getLength() > 0)) {
			for (int k = 0; k <= nl.getLength() - 1; k++) {
				final Node noeud = nl.item(k);
				
				final ProcessContext processContextNext = this.chaineNodeProcess(iCommandManager, noeud);

				// Agregate result
				if (processContextNext.getNodeProcessed() != null) {
					maListe.add(processContextNext.getNodeProcessed());
				}
				
			}
		}
		
		// Return result
		final ProcessContext context = new ProcessContext(maListe);
		return context;
	}

	public boolean accept(final ProcessContext processContext) {
		if (processContext.getNodeList() != null) {
			return true;
		} else {
			return false;
		}
	}

}
