package org.telosys.tools.repository.persistence.util;

import java.util.List;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class ProcessContext {

	private final NodeList nodeList;
	private final List list;
	private final Node node;
	private final Element element;
	private final Object nodeProcessed;
	
	public ProcessContext(NodeList nodeList) {
		super();
		this.nodeList = nodeList;
		this.list = null;
		this.node = null;
		this.element = null;
		this.nodeProcessed = null;
	}

	public ProcessContext(List list) {
		super();
		this.nodeList = null;
		this.list = list;
		this.node = null;
		this.element = null;
		this.nodeProcessed = null;
	}

	public ProcessContext(Node node) {
		super();
		this.nodeList = null;
		this.list = null;
		this.node = node;
		this.element = null;
		this.nodeProcessed = null;
	}

	public ProcessContext(Element element) {
		super();
		this.nodeList = null;
		this.list = null;
		this.node = null;
		this.element = element;
		this.nodeProcessed = null;
	}

	public ProcessContext(Object nodeProcessed) {
		super();
		this.nodeList = null;
		this.list = null;
		this.node = null;
		this.element = null;
		this.nodeProcessed = nodeProcessed;
	}

	public NodeList getNodeList() {
		return nodeList;
	}

	public List getList() {
		return list;
	}

	public Node getNode() {
		return node;
	}

	public Element getElement() {
		return element;
	}

	public Object getNodeProcessed() {
		return nodeProcessed;
	}

}
