package org.telosys.tools.repository.persistence.wrapper;

import org.telosys.tools.repository.model.RepositoryModel;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class BaseWrapper {
	
	public BaseWrapper() {
		super();
	}

	public RepositoryModel getBase(final Element base) {
		final RepositoryModel model = new RepositoryModel();
		model.setDatabaseName(base.getAttribute(RepositoryConst.TABLELIST_NAME));
		model.setDatabaseType(base.getAttribute(RepositoryConst.TABLELIST_TYPE));
		model.setGenerationDate(RepositoryConst.getDate(base.getAttribute(RepositoryConst.TABLELIST_GENERATION)));
		return model;
	}

	public Element getXmlDesc(final RepositoryModel model, final Document doc) {
		final Element table = doc.createElement(RepositoryConst.TABLELIST);
		table.setAttribute(RepositoryConst.TABLELIST_NAME, model.getDatabaseName());
		table.setAttribute(RepositoryConst.TABLELIST_TYPE, model.getDatabaseType());
		table.setAttribute(RepositoryConst.TABLELIST_GENERATION, RepositoryConst.DATE_TIME_ISO_FORMAT.format(model.getGenerationDate()));
		return table;
	}

}
