package org.telosys.tools.repository.persistence.wrapper;

import org.telosys.tools.repository.model.Entity;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class EntityWrapper {
	
	public EntityWrapper() {
		super();
	}

	public Entity getEntity(final Element table) {
		final Entity entity = new Entity();
		entity.setBeanJavaClass(table.getAttribute(RepositoryConst.TABLE_JAVA_BEAN));
		entity.setConverterJavaClass(table.getAttribute(RepositoryConst.TABLE_JAVA_BEAN_CONV));
		entity.setDaoJavaClass(table.getAttribute(RepositoryConst.TABLE_JAVA_BEAN_DAO));
		entity.setListJavaClass(table.getAttribute(RepositoryConst.TABLE_JAVA_BEAN_LIST));
		entity.setName(table.getAttribute(RepositoryConst.TABLE_NAME));
		entity.setCatalog(table.getAttribute(RepositoryConst.TABLE_CATALOG)); // v 1.0 #LGU
		entity.setSchema(table.getAttribute(RepositoryConst.TABLE_SCHEMA)); // v 1.0 #LGU
		return entity;
	}

	public Element getXmlDesc(final Entity entity, final Document doc) {
		final Element table = doc.createElement(RepositoryConst.TABLE);
		
		table.setAttribute(RepositoryConst.TABLE_JAVA_BEAN, entity.getBeanJavaClass());
		table.setAttribute(RepositoryConst.TABLE_JAVA_BEAN_CONV, entity.getConverterJavaClass());
		table.setAttribute(RepositoryConst.TABLE_JAVA_BEAN_DAO, entity.getDaoJavaClass());
		table.setAttribute(RepositoryConst.TABLE_JAVA_BEAN_LIST, entity.getListJavaClass());
		table.setAttribute(RepositoryConst.TABLE_NAME, entity.getName());		
		table.setAttribute(RepositoryConst.TABLE_CATALOG, entity.getCatalog()); // v 1.0 #LGU	
		table.setAttribute(RepositoryConst.TABLE_SCHEMA, entity.getSchema()); // v 1.0 #LGU
		return table;
	}

}
