package org.telosys.tools.repository.persistence.wrapper;

import org.telosys.tools.commons.StrUtil;
import org.telosys.tools.repository.model.ForeignKeyColumn;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class ForeignKeyColumnWrapper {

	public ForeignKeyColumn getForeignKeyColumn(final Element xmlElement) {
		
		final ForeignKeyColumn foreignKeyColumn = new ForeignKeyColumn();
		
		foreignKeyColumn.setTableName(xmlElement.getAttribute(RepositoryConst.FKCOL_TABLENAME));
		foreignKeyColumn.setColumnName(xmlElement.getAttribute(RepositoryConst.FKCOL_COLNAME) );
		
		foreignKeyColumn.setSequence( StrUtil.getInt(xmlElement.getAttribute(RepositoryConst.FKCOL_SEQUENCE)) );
		
		foreignKeyColumn.setTableRef(xmlElement.getAttribute(RepositoryConst.FKCOL_TABLEREF));
		foreignKeyColumn.setColumnRef(xmlElement.getAttribute(RepositoryConst.FKCOL_COLREF));
		
		foreignKeyColumn.setDeferrable(xmlElement.getAttribute(RepositoryConst.FKCOL_DEFERRABLE));
		foreignKeyColumn.setUpdateRule(xmlElement.getAttribute(RepositoryConst.FKCOL_UPDATERULE));
		foreignKeyColumn.setDeleteRule(xmlElement.getAttribute(RepositoryConst.FKCOL_DELETERULE));
		
		return foreignKeyColumn;
	}

	public Element getXmlDesc(final ForeignKeyColumn foreignKeyColumn, final Document doc) {
		
		final Element xmlElement = doc.createElement(RepositoryConst.FKCOL);
		
		xmlElement.setAttribute(RepositoryConst.FKCOL_TABLENAME, foreignKeyColumn.getTableName());
		xmlElement.setAttribute(RepositoryConst.FKCOL_COLNAME, foreignKeyColumn.getColumnName());
		
		xmlElement.setAttribute(RepositoryConst.FKCOL_SEQUENCE, Integer.toString(foreignKeyColumn.getSequence()) );

		xmlElement.setAttribute(RepositoryConst.FKCOL_TABLEREF, foreignKeyColumn.getTableRef());
		xmlElement.setAttribute(RepositoryConst.FKCOL_COLREF, foreignKeyColumn.getColumnRef());
		
		xmlElement.setAttribute(RepositoryConst.FKCOL_DEFERRABLE, foreignKeyColumn.getDeferrable());
		xmlElement.setAttribute(RepositoryConst.FKCOL_UPDATERULE, foreignKeyColumn.getUpdateRule());
		xmlElement.setAttribute(RepositoryConst.FKCOL_DELETERULE, foreignKeyColumn.getDeleteRule());
		
		return xmlElement;
	}
}
