package org.telosys.tools.repository.persistence.wrapper;

import org.telosys.tools.commons.StrUtil;
import org.telosys.tools.repository.model.JoinColumn;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class JoinColumnWrapper {

	public JoinColumnWrapper() {
		super();
	}

	public JoinColumn getJoinColumn(final Element table) {
		final JoinColumn joinColumn = new JoinColumn();
		
		joinColumn.setName(table.getAttribute(RepositoryConst.JOIN_COLUMN_NAME));
		joinColumn.setReferencedColumnName(table.getAttribute(RepositoryConst.JOIN_COLUMN_REFERENCEDCOLUMNNAME));
		
		if (StrUtil.nullOrVoid(table.getAttribute(RepositoryConst.JOIN_COLUMN_UNIQUE)) == false) {
			joinColumn.setUnique(StrUtil.getBoolean(table.getAttribute(RepositoryConst.JOIN_COLUMN_UNIQUE)));
		}
		if (StrUtil.nullOrVoid(table.getAttribute(RepositoryConst.JOIN_COLUMN_INSERTABLE)) == false) {
			joinColumn.setInsertable(StrUtil.getBoolean(table.getAttribute(RepositoryConst.JOIN_COLUMN_INSERTABLE)));
		}
		if (StrUtil.nullOrVoid(table.getAttribute(RepositoryConst.JOIN_COLUMN_NULLABLE)) == false) {
			joinColumn.setNullable(StrUtil.getBoolean(table.getAttribute(RepositoryConst.JOIN_COLUMN_NULLABLE)));
		}
		if (StrUtil.nullOrVoid(table.getAttribute(RepositoryConst.JOIN_COLUMN_UPDATABLE)) == false) {
			joinColumn.setUpdatable(StrUtil.getBoolean(table.getAttribute(RepositoryConst.JOIN_COLUMN_UPDATABLE)));
		}
		
		return joinColumn;
	}

	public Element getXmlDesc(final JoinColumn joinColumn, final Document doc) {
		final Element table = doc.createElement(RepositoryConst.JOIN_COLUMN_ELEMENT);
		
		table.setAttribute(RepositoryConst.JOIN_COLUMN_NAME, joinColumn.getName());
		table.setAttribute(RepositoryConst.JOIN_COLUMN_REFERENCEDCOLUMNNAME, joinColumn.getReferencedColumnName());
		table.setAttribute(RepositoryConst.JOIN_COLUMN_UNIQUE, Boolean.toString(joinColumn.isUnique()));
		table.setAttribute(RepositoryConst.JOIN_COLUMN_INSERTABLE, Boolean.toString(joinColumn.isInsertable()));
		table.setAttribute(RepositoryConst.JOIN_COLUMN_NULLABLE, Boolean.toString(joinColumn.isNullable()));
		table.setAttribute(RepositoryConst.JOIN_COLUMN_UPDATABLE, Boolean.toString(joinColumn.isUpdatable()));
		return table;
	}

}
