package org.telosys.tools.repository.persistence.wrapper;

import org.telosys.tools.commons.StrUtil;
import org.telosys.tools.repository.model.SequenceGenerator;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class SequenceGeneratorWrapper {
	
	public SequenceGeneratorWrapper() {
		super();
	}

	public SequenceGenerator getSequenceGenerator(final Element elem) {
		final SequenceGenerator sg = new SequenceGenerator();
		sg.setName(elem.getAttribute(RepositoryConst.SEQUENCE_GENERATOR_NAME));
		sg.setSequenceName(elem.getAttribute(RepositoryConst.SEQUENCE_GENERATOR_SEQUENCENAME));
		sg.setAllocationSize(StrUtil.getInt(elem.getAttribute(RepositoryConst.SEQUENCE_GENERATOR_ALLOCATIONSIZE)));
		return sg;
	}

	public Element getXmlDesc(final SequenceGenerator column, final Document doc) {
		final Element sg = doc.createElement(RepositoryConst.SEQUENCE_GENERATOR_ELEMENT);
		sg.setAttribute(RepositoryConst.SEQUENCE_GENERATOR_NAME, column.getName());
		sg.setAttribute(RepositoryConst.SEQUENCE_GENERATOR_SEQUENCENAME, column.getSequenceName());
		sg.setAttribute(RepositoryConst.SEQUENCE_GENERATOR_ALLOCATIONSIZE, Integer.toString(column.getAllocationSize()));
		return sg;
	}

}
