package org.telosys.tools.repository.persistence.wrapper;

import org.telosys.tools.repository.model.TableGenerator;
import org.telosys.tools.repository.persistence.util.RepositoryConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class TableGeneratorWrapper {
	
	public TableGeneratorWrapper() {
		super();
	}

	public TableGenerator getTableGenerator(final Element elem) {
		final TableGenerator tg = new TableGenerator();
		tg.setName(elem.getAttribute(RepositoryConst.TABLE_GENERATOR_NAME));
		tg.setTable(elem.getAttribute(RepositoryConst.TABLE_GENERATOR_TABLE));
		tg.setPkColumnName(elem.getAttribute(RepositoryConst.TABLE_GENERATOR_PKCOLUMNNAME));
		tg.setPkColumnValue(elem.getAttribute(RepositoryConst.TABLE_GENERATOR_PKCOLUMNVALUE));
		tg.setValueColumnName(elem.getAttribute(RepositoryConst.TABLE_GENERATOR_VALUECOLUMNNAME));
		return tg;
	}

	public Element getXmlDesc(final TableGenerator tg, final Document doc) {
		final Element element = doc.createElement(RepositoryConst.TABLE_GENERATOR_ELEMENT);
		element.setAttribute(RepositoryConst.TABLE_GENERATOR_NAME, tg.getName());
		element.setAttribute(RepositoryConst.TABLE_GENERATOR_TABLE, tg.getTable());
		element.setAttribute(RepositoryConst.TABLE_GENERATOR_PKCOLUMNNAME, tg.getPkColumnName());
		element.setAttribute(RepositoryConst.TABLE_GENERATOR_PKCOLUMNVALUE, tg.getPkColumnValue());
		element.setAttribute(RepositoryConst.TABLE_GENERATOR_VALUECOLUMNNAME, tg.getValueColumnName());
		return element;
	}

}
